## mergerfs 2.40.2

=== Makefile ===
#  Copyright (c) 2024, Antonio SJ Musumeci <trapexit@spawn.link>
#
#  Permission to use, copy, modify, and/or distribute this software for any
#  purpose with or without fee is hereby granted, provided that the above
#  copyright notice and this permission notice appear in all copies.
#
#  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
#  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
#  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
#  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
#  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
#  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

GIT 	  = git
TAR 	  = tar
MKDIR     = mkdir
TOUCH 	  = touch
CP        = cp
RM 	  = rm
LN        = ln
FIND 	  = find
INSTALL   = install
MKTEMP    = mktemp
STRIP     = strip
PANDOC    = pandoc
SED       = sed
RPMBUILD  = rpmbuild
GIT2DEBCL = ./buildtools/git2debcl
PKGCONFIG = pkg-config

GIT_REPO = 0
ifneq ($(shell $(GIT) --version 2> /dev/null),)
ifeq  ($(shell test -e .git; echo $$?),0)
GIT_REPO = 1
endif
endif

USE_XATTR = 1
UGID_USE_RWLOCK = 0

ifeq ($(DEBUG),1)
OPT_FLAGS := -O0 -g -fsanitize=undefined
else
OPT_FLAGS := -O2 -DNDEBUG
endif

ifeq ($(STATIC),1)
STATIC_FLAGS := -static
else
STATIC_FLAGS :=
endif

ifeq ($(LTO),1)
LTO_FLAGS := -flto
else
LTO_FLAGS :=
endif

SRC	    = $(wildcard src/*.cpp)
OBJS        = $(SRC:src/%.cpp=build/.src/%.o)
DEPS        = $(SRC:src/%.cpp=build/.src/%.d)

TESTS       = $(wildcard tests/*.cpp)
TESTS_OBJS  = $(filter-out build/.src/mergerfs.o,$(OBJS))
TESTS_OBJS += $(TESTS:tests/%.cpp=build/.tests/%.o)
TESTS_DEPS  = $(TESTS:tests/%.cpp=build/.tests/%.d)
TESTS_DEPS += $(DEPS)

MANPAGE     = mergerfs.1
CFLAGS      ?= ${OPT_FLAGS}
CFLAGS      := ${CFLAGS} \
               -Wall \
               -Wno-unused-result
CXXFLAGS    ?= ${OPT_FLAGS}
CXXFLAGS    := \
              ${CXXFLAGS} \
              -std=c++11 \
              $(STATIC_FLAGS) \
              $(LTO_FLAGS) \
              -Wall \
              -Wno-unused-result \
              -MMD
FUSE_FLAGS = \
              -Ilibfuse/include \
              -D_FILE_OFFSET_BITS=64
MFS_FLAGS  = \
	      -DUSE_XATTR=$(USE_XATTR) \
	      -DUGID_USE_RWLOCK=$(UGID_USE_RWLOCK)
TESTS_FLAGS = \
              -Isrc \
              -DTESTS

LDFLAGS := \
    ${LDFLAGS} \
    -pthread \
    -lrt

# https://www.gnu.org/prep/standards/html_node/Directory-Variables.html
DESTDIR       =
PREFIX        = /usr/local
EXEC_PREFIX   = $(PREFIX)
DATAROOTDIR   = $(PREFIX)/share
DATADIR       = $(DATAROOTDIR)
BINDIR        = $(EXEC_PREFIX)/bin
SBINDIR       = $(EXEC_PREFIX)/sbin
LIBDIR        = $(EXEC_PREFIX)/lib
MANDIR        = $(DATAROOTDIR)/man
MAN1DIR       = $(MANDIR)/man1

INSTALLBINDIR  = $(DESTDIR)$(BINDIR)
INSTALLSBINDIR = $(DESTDIR)$(SBINDIR)
INSTALLLIBDIR  = $(DESTDIR)$(LIBDIR)/mergerfs
INSTALLMAN1DIR = $(DESTDIR)$(MAN1DIR)

.PHONY: all
all: mergerfs

.PHONY: help
help:
	@echo "usage: make\n"
	@echo "make USE_XATTR=0      - build program without xattrs functionality"
	@echo "make STATIC=1         - build static binary"
	@echo "make LTO=1            - build with link time optimization"

objects: version build/stamp
	$(MAKE) $(OBJS)

tests-objects:
	$(MAKE) $(TESTS_OBJS)

build/mergerfs: libfuse objects
	$(CXX) $(CXXFLAGS) $(FUSE_FLAGS) $(MFS_FLAGS) $(CPPFLAGS) $(OBJS) -o $@ libfuse/build/libfuse.a $(LDFLAGS)

build/tests: build/mergerfs tests-objects
	$(CXX) $(CXXFLAGS) $(TESTS_FLAGS) $(FUSE_FLAGS) $(MFS_FLAGS) $(CPPFLAGS) $(TESTS_OBJS) -o $@ libfuse/build/libfuse.a $(LDFLAGS)

mergerfs: build/mergerfs

tests: build/tests

changelog:
ifeq ($(GIT_REPO),1)
	$(GIT2DEBCL) --name mergerfs > ChangeLog
else
	@echo "WARNING: need git repo to generate ChangeLog"
endif

.PHONY: version
version:
	./buildtools/update-version

build/stamp:
	$(MKDIR) -p build/.src build/.tests
	$(TOUCH) $@

build/.src/%.o: src/%.cpp
	$(CXX) $(CXXFLAGS) $(FUSE_FLAGS) $(MFS_FLAGS) $(CPPFLAGS) -c $< -o $@

build/.tests/%.o: tests/%.cpp
	$(CXX) $(CXXFLAGS) $(TESTS_FLAGS) $(FUSE_FLAGS) $(MFS_FLAGS) $(CPPFLAGS) -c $< -o $@

build/preload.so: build/stamp tools/preload.c
	$(CC) -shared -fPIC $(CFLAGS) $(CPPFLAGS) -o $@ tools/preload.c

preload: build/preload.so

.PHONY: clean
clean: rpm-clean
	$(RM) -rf build
	$(FIND) . -name "*~" -delete
	$(MAKE) -C libfuse clean

distclean: clean
ifeq ($(GIT_REPO),1)
	$(GIT) clean -xfd
endif

.PHONY: install
install: install-base install-mount-tools install-preload install-man

install-base: build/mergerfs
	$(MKDIR) -p "$(INSTALLBINDIR)"
	$(INSTALL) -v -m 0755 build/mergerfs "$(INSTALLBINDIR)/mergerfs"

install-mount-tools: install-base
	$(MKDIR) -p "$(INSTALLBINDIR)"
	$(MAKE) -C libfuse install

install-man: $(MANPAGE)
	$(MKDIR) -p "$(INSTALLMAN1DIR)"
	$(INSTALL) -v -m 0644 "man/$(MANPAGE)" "$(INSTALLMAN1DIR)/$(MANPAGE)"

install-preload: preload
	$(MKDIR) -p "$(INSTALLLIBDIR)"
	$(INSTALL) -v -m 444 "build/preload.so" "$(INSTALLLIBDIR)/preload.so"

install-strip: install-base
	$(STRIP) "$(INSTALLBINDIR)/mergerfs"

.PHONY: uninstall
uninstall: uninstall-base uninstall-mount.mergerfs uninstall-man

uninstall-base:
	$(RM) -f "$(INSTALLBINDIR)/mergerfs"

uninstall-mount.mergerfs:
	$(RM) -f "$(INSTALLBINDIR)/mount.mergerfs"

uninstall-man:
	$(RM) -f "$(INSTALLMAN1DIR)/$(MANPAGE)"

$(MANPAGE): README.md
ifneq ($(shell $(PANDOC) --version 2> /dev/null),)
	$(PANDOC) -s -t man -o "man/$(MANPAGE)" README.md
else
	$(warning "pandoc does not appear available: unable to build manpage")
endif

man: $(MANPAGE)

.PHONY: tarball
tarball: man changelog version
	$(eval VERSION := $(shell cat VERSION))
	$(eval VERSION := $(subst -,_,$(VERSION)))
	$(eval FILENAME := mergerfs-$(VERSION))
	$(eval TMPDIR := $(shell $(MKTEMP) --tmpdir -d .$(FILENAME).XXXXXXXX))
	$(MKDIR) $(TMPDIR)/$(FILENAME)
	$(CP) -ar . $(TMPDIR)/$(FILENAME)
	$(TAR) --exclude=.git -cz -C $(TMPDIR) -f $(FILENAME).tar.gz $(FILENAME)
	$(RM) -rf $(TMPDIR)

debian-changelog:
ifeq ($(GIT_REPO),1)
	$(GIT2DEBCL) --name mergerfs > debian/changelog
else
	cp ChangeLog debian/changelog
endif

signed-deb:
	$(MAKE) distclean
	$(MAKE) debian-changelog
#	dpkg-source -b .
	dpkg-buildpackage -nc

deb:
	$(MAKE) distclean
	$(MAKE) debian-changelog
#	dpkg-source -b .
	dpkg-buildpackage -nc -uc -us

.PHONY: rpm-clean
rpm-clean:
	$(RM) -rf rpmbuild

rpm: tarball
	$(eval VERSION := $(shell cat VERSION))
	$(eval VERSION := $(subst -,_,$(VERSION)))
	$(MKDIR) -p rpmbuild/BUILD rpmbuild/RPMS rpmbuild/SOURCES
	$(SED) 's/__VERSION__/$(VERSION)/g' mergerfs.spec > \
		rpmbuild/SOURCES/mergerfs.spec
	cp -ar mergerfs-$(VERSION).tar.gz rpmbuild/SOURCES
	$(RPMBUILD) -ba rpmbuild/SOURCES/mergerfs.spec \
		--define "_topdir $(CURDIR)/rpmbuild"

.PHONY: install-build-pkgs
install-build-pkgs:
	./buildtools/install-build-pkgs

.PHONY: libfuse
libfuse:
	$(MAKE) DEBUG=$(DEBUG) -C libfuse

-include $(DEPS)

=== libfuse/Makefile ===
VERSION = 2.9.7-mergerfs_2.30.0

OS := $(shell uname -s)
ifeq ($(OS),Linux)
UTILS := utils
INSTALLUTILS := install-utils
else
UTILS :=
INSTALLUTILS :=
endif

ifeq ($(DEBUG),1)
OPT_FLAGS := -O0 -g -fsanitize=undefined
else
OPT_FLAGS := -O2
endif

ifeq ($(LTO),1)
LTO_FLAGS := -flto
else
LTO_FLAGS :=
endif

DESTDIR       =
PREFIX        = /usr/local
EXEC_PREFIX   = $(PREFIX)
DATAROOTDIR   = $(PREFIX)/share
DATADIR       = $(DATAROOTDIR)
BINDIR        = $(EXEC_PREFIX)/bin
SBINDIR       = /sbin
MANDIR        = $(DATAROOTDIR)/man
MAN1DIR       = $(MANDIR)/man1

INSTALLBINDIR  = $(DESTDIR)$(BINDIR)
INSTALLSBINDIR = $(DESTDIR)$(SBINDIR)
INSTALLMAN1DIR = $(DESTDIR)$(MAN1DIR)

AR ?= ar

SRC_C = \
	lib/buffer.c \
	lib/crc32b.c \
	lib/debug.c \
	lib/fuse.c \
	lib/fuse_dirents.c \
	lib/fuse_lowlevel.c \
	lib/node.c \
	lib/fuse_node.c \
	lib/fuse_opt.c \
	lib/fuse_session.c \
	lib/fuse_signals.c \
	lib/helper.c \
	lib/mount.c
SRC_CPP = \
	lib/format.cpp \
	lib/os.cpp \
	lib/cpu.cpp \
	lib/fuse_config.cpp \
	lib/fuse_loop.cpp \
	lib/fuse_msgbuf.cpp
OBJS_C   = $(SRC_C:lib/%.c=build/%.o)
OBJS_CPP = $(SRC_CPP:lib/%.cpp=build/%.o)
DEPS_C   = $(SRC_C:lib/%.c=build/%.d)
DEPS_CPP = $(SRC_CPP:lib/%.cpp=build/%.d)
CFLAGS ?= \
	$(OPT_FLAGS)
CFLAGS := \
	${CFLAGS} \
	$(LTO_FLAGS) \
	-std=gnu99 \
	-Wall \
	-pipe \
	-MMD
CXXFLAGS := \
	${CXXFLAGS} \
	$(LTO_FLAGS) \
	-std=c++11 \
	-Wall \
	-pipe \
	-MMD
FUSERMOUNT_DIR = $(BINDIR)
FUSE_FLAGS = \
	-Iinclude \
	-Ibuild \
	-D_REENTRANT \
	-D_FILE_OFFSET_BITS=64 \
	-DPACKAGE_VERSION=\"$(VERSION)\" \
	-DFUSERMOUNT_DIR=\"$(FUSERMOUNT_DIR)\"
LDFLAGS := \
	${LDFLAGS} \
	-lrt \
	-pthread

all: build/libfuse.a $(UTILS)

build/config.h: build/stamp
	ecfd/build | tee build/config.h

build/stamp:
	mkdir -p build
	touch $@

objects: build/config.h
	$(MAKE) $(OBJS_C) $(OBJS_CPP)

build/libfuse.a: objects
	${AR} rcs build/libfuse.a $(OBJS_C) $(OBJS_CPP)

utils: mergerfs-fusermount mount.mergerfs

build/mergerfs-fusermount: build/config.h util/fusermount.c lib/mount_util.c
	$(CC) $(CFLAGS) $(FUSE_FLAGS) -Ilib -o build/mergerfs-fusermount util/fusermount.c lib/mount_util.c

mergerfs-fusermount: build/mergerfs-fusermount

build/mount.mergerfs: build/libfuse.a util/mount.mergerfs.c
	$(CC) $(CFLAGS) $(FUSE_FLAGS) -o build/mount.mergerfs util/mount.mergerfs.c build/libfuse.a $(LDFLAGS)

mount.mergerfs: build/mount.mergerfs

build/%.o: lib/%.c
	$(CC) $(CFLAGS) $(FUSE_FLAGS) -c $< -o $@

build/%.o: lib/%.cpp
	$(CXX) $(CXXFLAGS) $(FUSE_FLAGS) -c $< -o $@

clean:
	rm -rf build

distclean: clean

strip:
	strip --strip-all build/mount.mergerfs
	strip --strip-all build/mergerfs-fusermount

install-utils: mergerfs-fusermount mount.mergerfs strip
	install -D build/mergerfs-fusermount "$(INSTALLBINDIR)/mergerfs-fusermount"
	install -D build/mount.mergerfs "$(INSTALLSBINDIR)/mount.mergerfs"
	chown root "$(INSTALLBINDIR)/mergerfs-fusermount"
	chmod u+s "$(INSTALLBINDIR)/mergerfs-fusermount"

install: $(INSTALLUTILS)

.PHONY: objects strip utils install install-utils

-include $(DEPS_C) $(DEPS_CPP)

=== debian/changelog ===
mergerfs (2.40.2-5) unstable; urgency=medium

  * Refresh patches
  * Add patch to fix build on armel

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 31 Jan 2025 21:33:09 +0530

mergerfs (2.40.2-4) unstable; urgency=medium

  * Mandate Rules-Requires-Root: binary-targets (Closes: #1089386)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 31 Jan 2025 17:34:53 +0530

mergerfs (2.40.2-3) unstable; urgency=medium

  * Disable the preload feature
    - It breaks the `moveonenospc` functionality.
    - It currently FTBFS on many architectures on Debian

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 24 Oct 2024 21:45:17 +0530

mergerfs (2.40.2-2) unstable; urgency=medium

  * Include NMU fixes missed out

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 17 Oct 2024 20:57:19 +0530

mergerfs (2.40.2-1) unstable; urgency=medium

  * New upstream version 2.40.2 (Closes: #1033303)
  * Refresh patches
  * Depend on ordered fuse versions (Closes: #1084429)
  * Document the option about setuid-root on binary (Closes: 1037058)
  * Drop the libfuse-dev build dependency

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 17 Oct 2024 20:33:01 +0530

mergerfs (2.33.5-2) unstable; urgency=medium

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Ritesh Raj Sarraf ]
  * Drop hardcoded runtime dependency on libfuse2 (Closes: 1068120)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 15 Apr 2024 20:27:59 +0530

=== debian/control ===
Source: mergerfs
Section: utils
Priority: optional
Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~),
 libattr1-dev
Standards-Version: 4.6.1
Rules-Requires-Root: binary-targets
Homepage: https://github.com/trapexit/mergerfs
Vcs-Git: https://salsa.debian.org/debian/mergerfs.git
Vcs-Browser: https://salsa.debian.org/debian/mergerfs

Package: mergerfs
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 fuse3 (>= 3.10.1-3) | fuse (<< 3)
Description: another FUSE union filesystem
 mergerfs is a union filesystem geared towards simplifying storage and
 management of files across numerous commodity storage devices. It is
 similar to mhddfs, unionfs, and aufs.
 .
 Some salient features include
  * Runs in userspace (FUSE)
  * Configurable behaviors
  * Support for extended attributes (xattrs)
  * Support for file attributes (chattr)
  * Runtime configurable (via xattrs)
  * Safe to run as root
  * Opportunistic credential caching
  * Works with heterogeneous filesystem types
  * Handling of writes to full drives
  * Handles pool of readonly and read/write drives

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# For Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
-include /usr/share/dpkg/buildtools.mk
export CC
export CXX
export DEBUG = 1

# Disable git calling for cleaning
export GIT_REPO = 0

%:
	dh $@

override_dh_autoreconf:
	# Because there's no auto* files shipped anymore

override_dh_auto_install:
	$(MAKE) DESTDIR=$(CURDIR)/debian/mergerfs PREFIX=/usr SBINDIR=/usr/sbin install STRIP=true
